# Урок

:project Programming

## Переменные

:overlay

:position 30,30,40,40

:navigate projects.code.console

### Переменные

Переменные являются неотъемлемой частью языков программирования. Переменная это место в памяти компьютера, содержащее значение и
обозначаемое идентификатором, выбранным программистом.

Во время этого урока не стесняйтесь копировать различные примеры в консоль или экспериментировать со своими собственными.

## Переменные

:navigate projects.code.console

:position 55,30,40,40

### Переменные

Переменные существуют для того, чтобы облегчить вашу работу! Например, они позволяют нам писать:

```
furniture = chairs + tables
```

Вместо:

```
memory_514 = memory_23 + memory_1289
```

Этот последний пример может звучать лучше для компьютера, но для человека его будет гораздо сложнее
прочитать!

## Присвоение значения переменной

:navigate projects.code.console

### Присвоение значения переменной

Присвоение значения переменной означает запрос на сохранение значения. Для этого мы используем знак ```=```, например:

```
myVariable = 1000
```

В microScript достаточно просто присвоить значение переменной, чтобы определить ее (т.е. назначить ей слот памяти). Переменная, которая еще не определена и поэтому не имеет зарезервированного слота памяти, всегда будет иметь значение по умолчанию ```0```.

## Именование переменных

:navigate projects.code.console

### Присвойте имя переменным

Существует несколько правил правильного именования переменных. В microScript вы должны использовать только буквы алфавита без какого-либо акцента. Вы можете использовать их в верхнем или нижнем регистре.
Другие разрешенные символы включают символ "подчеркивания" ```_```, а также могут использоваться цифры от 0 до 9, за исключением первого символа имени переменной.


## Именование переменных

:navigate projects.code.console

### Присвойте имя переменным

Примеры:
```
// правильно названные переменные

score = 100
Player_1 = 0

// неправильные переменные:

2_players = 2 // вы не можете начинать с цифры!
my character = 3 // пробелы не допускаются!
```

## Именование переменных

### Присвойте имя переменным

В дополнение к этим правилам мы советуем вам выбирать достаточно описательные имена переменных. Это облегчит читаемость вашего кода.
Например, вам лучше использовать:

```
number_of_carrots = 25
```

это лучше, чем:

```
c = 25
```

## Типы значений

:navigate projects.code.console

### Типы значений

Переменные в microScript могут хранить несколько типов значений:

* Число, например 15, 7 или 3.141592
* Некоторый текст, который мы будем называть типом "строка" (потому что это *строка символов*). Пример: "Привет",
"Ты выиграл!"...
* Функция (изучается позже в этом курсе). Пример: ```function(x) return x*x end```
* Список (изучается позже в этом курсе). Пример: ```[1, 3, 5, 7]``` или ```["собака", "кошка", "кролик"]```.
* Объект (изучается позже в этом курсе). Пример: ```object x=1 y=2 end```

## Использование переменной

### Использование переменной

Переменная может быть использована в любом *выражении* программы и затем быть заменено ее текущее значение во время выполнения.

```
score = 124
text = "Ваш счет равен "
display = text + score
print( display )
```

В приведенном выше примере функция "print" отображает в консоли значение, которое передается ей в качестве параметра (в скобках).

Оператор ```+``` при использовании в строке управляет объединением символьных строк (он соединяет два фрагмента текста). Таким образом, значение
переменной "display" выше будет равно "Ваш счет равен 124".

## Сфера действия и контекст

:navigate projects.code.console

### Видимость и контекст

Переменные, которые мы определяли до сих пор, являются глобальными, т.е. они принадлежат общей памяти программы и могут использоваться в любом месте программы.

В ходе изучения функций и объектов мы увидим, что некоторые переменные могут иметь ограниченную *видимость* или "область действия". Например, функция, которая является своего рода подпрограммой, сможет определять и использовать *локальную переменную*, которая будет известна только в теле функции и следовательно невидима в других местах.